#include <fstream>
#include <iostream>
#include <stdio.h>
#include <string>
#include "IMA_ADPCM.cpp"
	



 int main(int argc, char * argv[])
{


  unsigned char rawHead[60] = { //pseudo header for pcm mono, 22050 
	0x52, 0x49, 0x46, 0x46, 0x49, 0x5E, 0x00, 0x00, 0x57, 0x41, 0x56, 0x45, 0x66,
    0x6D, 0x74, 0x20, 0x14, 0x00, 0x00, 0x00, 0x11, 0x00, 0x01, 0x00, 0x22, 0x56,
    0x00, 0x00, 0x11, 0x2B, 0x00, 0x00, 0x04, 0x04, 0x04, 0x00, 0x02, 0x00, 0x00,
    0x08, 0x66, 0x61, 0x63, 0x74, 0x04, 0x00, 0x00, 0x00, 0x06, 0x77, 0x01, 0x00,
    0x64, 0x61, 0x74, 0x61, 0x15, 0x5E, 0x00, 0x00, 
	} ;
	
  FILE *pcmFile, *pcmtemp; //c read n' write
  IMA_ADPCM DeCom;
  string OrigFile, FileTemp, DecmFile, ApndPath;
  
  //use string dissection to append/build desired pathways -
   
         if(argv[1]>0)
          {
           FileTemp=argv[1];
           ApndPath=argv[1];
           OrigFile=argv[1];
           int keeppath = FileTemp.rfind("\\");
           FileTemp.erase(0,keeppath+1);
           int killname = FileTemp.rfind(".");
           FileTemp.erase(killname);
           
           int findpath = ApndPath.find_last_of("\\");
           ApndPath.erase(findpath+1);
           
           ApndPath+="Enc_";
           ApndPath+=FileTemp;
           ApndPath+=".wav";
           
           }
         else {
         
           cout<<"Drag n' drop pcm, 22050 mono wave file onto"
           " window.  Press [enter] to exit ";
           cin.get();
        
            return 0; //kill program if no wav file dropped
           }
           
   //Open file (c++ method): we need to do some approximate
   //size computations.  Also do a half_ass job of checking
   //for either a missing or incorrect file_type. Mostly we
   //look for wav format 16', which is a standard pcm wave,
   //also check to verify selection is mono (single channel)
   //and sample_rate is 22050 -
   
   
   fstream wavType (OrigFile.c_str(), ios::in | ios::bin);
   wavType.seekg(0, ios::end);
   int dsize = wavType.tellg();
   wavType.seekg(0x16, ios::beg);
   
         unsigned char balign, nuchan;
         unsigned long samp_rate;
         unsigned long wvformat;
         
         wavType.seekg(0x10,ios::beg);
         wavType.read(&wvformat,4);
         wavType.seekg(2, ios::cur);
         wavType.read(&nuchan, 1);    //check channel #
         wavType.seekg(1,ios::cur);
         wavType.read(&samp_rate, 4);
   
         wavType.close();
   
/* ************************************************************************* */

  if(wvformat==16 && samp_rate==22050 && nuchan==1){

   int datawav=dsize-44; //deduct wav header for pcm size
   
   datawav=datawav/4096;//gives us our # for loop de loop
   
   dsize = dsize-2056; //approx. size of decompressed wav
   unsigned long DeCom_Size = dsize; //file value at 0x30
   //Note:  this value can be approximated, provided that
   //its value does not exceed or seriously underestimate
   //wave data_size after decompression -
 
 
   unsigned long PcmFileSize;
   pcmtemp=fopen(OrigFile.c_str(), "rb");
   fseek(pcmtemp, 0x28, SEEK_SET);
   fread(&PcmFileSize, sizeof(unsigned long), 1, pcmtemp);
   fread(&HeaderVal, sizeof(int16_t), 1, pcmtemp);
   
   int16_t buffer[2047];
   int buf_os = 16;   //skip sample_2 -step_index precursor
   unsigned char enc_buffer[1026];
   size_t enc_outsize = 4096;
   
   /* Note:  1028 is the precise data length from header to
   *  to header in an exported trespasser adpcm file.  This
   *  refers to the 1st & 2nd sample block of its header n'
   *  then proceeds to the next header of the next block. I
   *  am certain this is correct from studying the exported
   *  ima/dvi files from tpas. The first sample of a header
   *  is the PredictedValue, the 2nd sample presumably used
   *  as seeder to attain optimum StepIndex.
   */
 
        pcmFile = fopen(ApndPath.c_str(), "wb");
        fwrite(&rawHead,sizeof(char),60,pcmFile);
        
   //loop thru file - rightfully, if a full 2048 block can't
   //be read in, file should be padded with 0s to consist of
   //valid block size, but since it isn't necessary for wave
   //validity (for it to play) file balance isn't a concern,
   //so long as preceding block alignments are correct -
         
   //attempt to use loop to control buffer overwrite. Not so
   //effective -
   
     int xyz=0;
         
     while(xyz<datawav)
    {
         fread(&buffer, sizeof(int16_t), 2047, pcmtemp);
         
         DeCom.Encode(enc_buffer, buf_os, buffer, enc_outsize);
         
         fwrite(&HeaderVal, sizeof(int16_t), 1, pcmFile);
         fwrite(&enc_buffer, sizeof(enc_buffer), 1, pcmFile);
         
         fread(&HeaderVal, sizeof(int16_t), 1, pcmtemp);
         ++xyz;
         }
     
  fclose(pcmFile);
  fclose(pcmtemp);
  
  //Don't mix c & c++.  Bull, I do it all the time.  <chuckles>
 
  fstream numbs(ApndPath.c_str(), ios::in | ios::out |ios::bin);
        numbs.seekg( 0, ios::end );
        int numsize = numbs.tellg();
        numbs.seekg( 4, ios::beg );
        
        //Normally, these values should be computated -
        int Value_One=numsize-8;  // file size - header
        int Value_Two=numsize-60; //compressed wav size
        
        long minusfileid = Value_One;
        long minusheader = Value_Two;
        
   numbs.write((long *)(&minusfileid), sizeof(minusfileid));
   numbs.seekg( 0x28, ios::cur ); 
   numbs.write((long *)(&DeCom_Size), sizeof(DeCom_Size));
   numbs.seekg(0x4, ios::cur);
   numbs.write((long *)(&minusheader), sizeof(minusheader));
   numbs.close();
    }
   else {
         std::cout<< "Wave file is already encoded, or wav type is\n"
         "stereo or unknown.  Press [enter] to exit ";
         std::cin.get();
        }      

  return 0;
}
